unit zcgi;
// **************    CGI **********
//  , z-ol.chat.ru

interface
uses Classes, Windows, Sysutils;
 type
 // ,   
 TCGIParamsParser = class
  private
    FParamStr: string;
    FCookiesStr: string;
    procedure SetParamStr(const Value: string);
    procedure ParseString(AStr : String; ADivChar: Char; AParamList : TStrings);
    procedure SetCookiesStr(const Value: string);
    protected
     FParamList   : TStrings;
     FCookiesList : TStrings;
    public
     Constructor Create;  // 
     Destructor  Destroy; // 
     //    
     Function    GetParamVal(AName : string;DefVal : string = ''): string;
     //  cookie  
     Function    GetCookieVal(AName : string;DefVal : string = ''): string;
    published
     //  
     Property ParamStr: string read FParamStr write SetParamStr;
     //  Cookies
     Property CookiesStr: string read FCookiesStr write SetCookiesStr;
   end;
 //      
 Function GetEnv(AName : string) : String;
 //  
 Function DecodeParam(AParam : string) : String;
 //  
 Function CodeParam(AParam : string) : String;
implementation

//      
Function GetEnv(AName : string) : String;
var
 Buf : array[0..16000] of char;
begin
 GetEnvironmentVariableA(PChar(AName), Buf, SizeOf(buf));
 Result := Buf;
end;

//  
Function DecodeParam(AParam : string) : String;
var
 i : integer;
begin
 Result := '';
 if AParam = '' then exit;
 i := 1;
 while i <= Length(AParam) do
  case AParam[i] of
   '+' : begin
          Result := Result + ' ';
          inc(i);
         end;
   '%' : begin
          try
           Result := Result + Chr(StrToInt('$'+Copy(AParam,i+1,2)));
          except end;
          inc(i, 3); //  % +    
         end;
   else begin
          Result := Result + AParam[i];
          inc(i);
         end;
  end;
end;

//  
Function CodeParam(AParam : string) : String;
var
 i : integer;
begin
 Result := '';
 for i := 1 to Length(AParam) do
  case AParam[i] of
   ' ' : Result := Result + '+';
   'A' .. 'Z',
   'a' .. 'z',
   '1' .. '9','0' : Result := Result + AParam[i];
   else Result := Result + '%' + IntToHex(ord(AParam[i]), 2);
  end; 
end;

 { *************** TCGIParamsParser ******************** }
// 
constructor TCGIParamsParser.Create;
begin
 FParamList   := TStringList.Create;
 FCookiesList := TStringList.Create;
end;

// 
Destructor  TCGIParamsParser.Destroy;
begin
 FParamList.Free;
end;

//  
procedure TCGIParamsParser.ParseString(AStr: String; ADivChar: Char; AParamList : TStrings);
var
 s, st : string;
begin
 AParamList.Clear;
 // 
 s := AStr + ADivChar;
 while pos(ADivChar, s) > 0 do begin
  st := Copy(s, 1, pos(ADivChar, s)-1);
  Delete(s, 1, pos(ADivChar, s));
  if Trim(st) <> '' then
   AParamList.Add(DecodeParam(Trim(st)));
 end;
end;

//   ,    
procedure TCGIParamsParser.SetParamStr(const Value: string);
begin
  FParamStr := Value;
  ParseString(Value, '&', FParamList);
end;

//   Cookies,    
procedure TCGIParamsParser.SetCookiesStr(const Value: string);
begin
  FCookiesStr := Value;
  ParseString(Value, ';', FCookiesList);
end;

//   
function TCGIParamsParser.GetParamVal(AName: string;DefVal : string = ''): string;
begin
 Result := FParamList.Values[AName];
 if Result = '' then
  Result := DefVal;
end;

//  cookie  
function TCGIParamsParser.GetCookieVal(AName, DefVal: string): string;
begin
 Result := FCookiesList.Values[AName];
 if Result = '' then
  Result := DefVal;
end;

end.